//============================================================================
// Name        : TCCP.cpp
// Author      : qwan
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include "timer.h"
#include <stdio.h>
#include <vector>
#include <set>
#include <stack>
#include "data.h"

using namespace std;

long counter_dom1 = 0;
long counter_dom2 = 0;
long counter_comp1 = 0;
long counter_comp2 = 0;
long counter_con = 0;
long counter_del1 = 0;
long counter_del2 = 0;

long counter_inf_hit = 0;
long counter_ninf_hit = 0;
long counter_total = 0;
double add_error, big_delta;
double profit_greedy0, profit_optimal;

#define _MAX 6553500
#define _LIST_UNDEFINED 0

int max(int x, int y)
{
	if (x>y)
		return x;
	else return y;
}

int min(int x, int y)
{
	if (x<y)
		return x;
	else return y;
}

int load_file(char *dir) {

	created = new PtsSpace;
	exsiting = new PtsSpace;
	cpl = new PtsSpace;
	cpu = new PtsSpace;

	bool created_bnl = true;
	bool exsiting_bnl = true;
	bool cp_bnl=true;

	FILE* pFile;
	char  temp[1024];


	sprintf(temp,"./%s/new_table.txt",dir);
	printf("%s\n",temp);
	if ((pFile = fopen(temp, "r")) == NULL) {
		printf("reading error1!!!");
		return 0;
	}

	/*
	 if ((pFile = fopen("./created.txt", "r")) == NULL) {
	 if ((pFile = fopen("./new_table.txt", "r")) == NULL) {
	 printf("reading error!!!");
	 return 0;
	 }

	 created_bnl = true;

	 }
	 */

	int tuple, dim;

	fscanf(pFile, "%d %d", &tuple, &dim);
	domain = new set<int> [dim];

	created->init(dim, tuple, dim - 1);

	for (int i = 0; i < created->tupleNum; i++) {
		for (int j = 0; j < created->dimNum; j++) {
			fscanf(pFile, "%d", &(created->v[i][j]));
			domain[j].insert(created->v[i][j]);
			if (j == created->dimNum - 1) {
				created->v[i][j] = ceil(setting.d * created->v[i][j]);
			}
		}
	}

	fclose(pFile);
	
	if(setting.t==3)
	{
	sprintf(temp,"./%s/customer_table.txt",dir);
	printf("%s\n",temp);
	if ((pFile = fopen(temp, "r")) == NULL) {
		printf("reading error2!!!");
		return 0;
	}
	
	fscanf(pFile, "%d %d", &tuple, &dim);
//	cpl->init(dim+1, tuple, dim);
	cpu->init(dim+1, tuple, dim);
	
	for (int i = 0; i < cpu->tupleNum; i++) {
		for (int j = 0; j < cpu->dimNum-1; j++) {
			fscanf(pFile, "%d", &(cpu->v[i][j]));
			if(j<floor((double)(cpu->dimNum-1)/2))
				cpu->v[i][j]=min(10,cpu->v[i][j]+setting.r1);
			else
				cpu->v[i][j]=min(10000,cpu->v[i][j]+setting.r2);
//			cpl->v[i][j]=0;
		}
		cpu->v[i][cpu->dimNum-1]=i;
//		cpl->v[i][cpl->dimNum-1]=i;
	}

	fclose(pFile);
	//	cpl->build_index();
	cpu->build_index();
	sprintf(temp,"./%s/customerpre.txt",dir);
	if (cp_bnl) {
		cpu->tofile(temp);
	}
  }
	sprintf(temp,"./%s/existing_table.txt",dir);
	printf("%s\n",temp);
	if ((pFile = fopen(temp, "r")) == NULL) {
		printf("reading error3!!!");
		//exit(0);
		return 0;
	}

	fscanf(pFile, "%d %d", &tuple, &dim);
	exsiting->init(dim, tuple, dim - 1);

	for (int i = 0; i < exsiting->tupleNum; i++) {
		for (int j = 0; j < exsiting->dimNum; j++) {
			fscanf(pFile, "%d", &(exsiting->v[i][j]));
		}
	}

	fclose(pFile);
	if (created_bnl) {
		created->bnl();
	}

	if (exsiting_bnl) {
		exsiting->bnl();
	}

	created->reverseSort(0);

	created->build_index();
	exsiting->build_index();
	




	if (created_bnl) {
		sprintf(temp,"./%s/created.txt",dir);
		created->tofile(temp);
	}

	if (exsiting_bnl) {
		sprintf(temp,"./%s/exsiting.txt",dir);
		exsiting->tofile(temp);
	}
	


	list_delta_dom = new int[created->tupleNum];
	list_delta_comp = new int[created->tupleNum];
	list_delta_dom2 = new int[created->tupleNum];
	list_delta_comp2 = new int[created->tupleNum];

	//	int count = setting.k;
	//	scale = new long[dim];

	//	scale[0] = 1;
	//
	//	for (int i=0;i<dim-1; i++){
	//		scale[i+1] = count;
	//		count *= domain[i].size();
	//		printf("%ld:",scale[i+1]);
	//	}

	//	T = new int[count];
	//	memset(T, 0, count * sizeof(int));
	//	S = new set<int>[count];

	//s	result_count = count;

	memset(list_delta_comp, _LIST_UNDEFINED, sizeof(int) * created->tupleNum);
	memset(list_delta_dom, _LIST_UNDEFINED, sizeof(int) * created->tupleNum);
	memset(list_delta_comp2, _LIST_UNDEFINED, sizeof(int) * created->tupleNum);
	memset(list_delta_dom2, _LIST_UNDEFINED, sizeof(int) * created->tupleNum);

	return 0;
}
;

int load_update(char *dir) {
	
	FILE *pFile;
	char temp[1024];
	inserttuple= new PtsSpace;
	deletetuple= new PtsSpace; 
	
	

	int tuple, dim;
	if (setting.t==1 || setting.t==5)
	{
	sprintf(temp,"./%s/insert_table.txt",dir);
	if ((pFile = fopen(temp, "r")) == NULL) {
		printf("reading error!!!");
		return 0;
	}
	fscanf(pFile, "%d %d", &tuple, &dim);
//	domain = new set<int> [dim];

	inserttuple->init(dim, tuple, dim - 1);

	for (int i = 0; i < inserttuple->tupleNum; i++) {
		for (int j = 0; j < inserttuple->dimNum; j++) {
			fscanf(pFile, "%d", &(inserttuple->v[i][j]));
//			domain[j].insert(inserttuple->v[i][j]);
//			if (j == created->dimNum - 1) {
//				inserttuple->v[i][j] = ceil(setting.d * inserttuple->v[i][j]);
//			}
		}
	}

	fclose(pFile);
	}
	
	if (setting.t==4 || setting.t==5)
	{
	sprintf(temp,"./%s/delete_table.txt",dir);  
	if ((pFile = fopen(temp, "r")) == NULL) {
		printf("reading error!!!");
		return 0;
	}
	
	fscanf(pFile, "%d %d", &tuple, &dim);
//	domain = new set<int> [dim];

	deletetuple->init(dim, tuple, dim - 1);

	for (int i = 0; i < deletetuple->tupleNum; i++) {
		for (int j = 0; j < deletetuple->dimNum; j++) {
			fscanf(pFile, "%d", &(deletetuple->v[i][j]));
//			domain[j].insert(inserttuple->v[i][j]);
//			if (j == created->dimNum - 1) {
//				deletetuple->v[i][j] = ceil(setting.d * deletetuple->v[i][j]);
//			}
		}
	}
	
	fclose(pFile);	
	}
}

int price_dom(int q) {
	/*
	 * return -_MAX if -inf
	 * return _MAX if +inf
	 * return min otherwise
	 * */

	//check +inf
	if (setting.h == 0) {
		return _MAX;
	}

	counter_total++;

	//check cache
	if (list_delta_dom[q] != _LIST_UNDEFINED) {

		if (list_delta_dom[q] >= _MAX) {
			counter_inf_hit++;
		} else if (list_delta_dom[q] <= -_MAX) {
			counter_ninf_hit++;
		}

		return list_delta_dom[q];
	}

	//calculate value of delta_dom

	counter_dom1++;

	int min = _MAX;
	//delta_dom
	if (setting.h > 0) {
		int* v1 = created->v[q];
		int* v2 = new int[created->dimNum];

		for (int i = 0; i < created->dimNum; i++) {
			v2[i] = _MAX;
		}

		Pt_Collection* pcp = exsiting->rect_query(v1, v2);

		if (pcp->size() >= setting.h) {
			PtsSpace* pt = exsiting->Product(pcp);
			pt->sort(pt->dimNum - 1);
			if (min > pt->v[setting.h - 1][pt->dimNum - 1]) {
				min = pt->v[setting.h - 1][pt->dimNum - 1];
			}
			delete pt;
		} else {
			delete pcp;
			delete[] v2;
			list_delta_dom[q] = -_MAX;
			counter_ninf_hit++;
			return -_MAX;
		}

		delete pcp;
		delete[] v2;
	}

	list_delta_dom[q] = min;

	if (min >= _MAX) {
		counter_inf_hit++;
	} else if (min <= -_MAX) {
		counter_ninf_hit++;
	}

	return min;
}


int price_comp(int q) {
	/*
	 * return -_MAX if -inf
	 * return _MAX if +inf
	 * return min otherwise
	 * */

	counter_total++;

	if (list_delta_comp[q] != 0) {
		if (list_delta_comp[q] >= _MAX) {
			counter_inf_hit++;
		}
		return list_delta_comp[q];
	}

	counter_comp1++;

	int min = _MAX;

	int* v1 = new int[exsiting->dimNum - 1];
	memset(v1, 0, sizeof(int) * (exsiting->dimNum - 1));

	Pt_Collection* pcp = exsiting->rect_query(v1, created->v[q]);

	if (pcp->size() == 0) {
		delete pcp;
		delete[] v1;
		counter_inf_hit++;
		return _MAX;
	}

	PtsSpace* pt2 = exsiting->Product(pcp);

	pt2->calM();

	if (min > pt2->min[created->dimNum - 1]) {
		min = pt2->min[created->dimNum - 1];
	}

	delete[] v1;
	delete pt2;
	delete pcp;
	//	return min - setting.sigma - created->v[q][created->dimNum-1];

	list_delta_comp[q] = min;

	return min;
}

int price_dom(int q, PtsSpace* local_created) {
	/*
	 * return -_MAX if -inf
	 * return _MAX if +inf
	 * return min otherwise
	 * */

	if (setting.h == 0) {
		return _MAX;
	}

	counter_dom2++;

	Pt_Collection* tpc = created->rect_query(local_created->v[q],
			local_created->v[q]);
	Pt_Collection::iterator tpc_iter = tpc->begin();

	if (list_delta_dom2[*tpc_iter] != 0) {
		int re = list_delta_dom2[*tpc_iter];
		delete tpc;
		return re;
	}

	int min = _MAX;

	//delta_dom
	if (setting.h > 0) {
		int* v1 = local_created->v[q];
		int* v2 = new int[local_created->dimNum];

		for (int i = 0; i < local_created->dimNum; i++) {
			v2[i] = _MAX;
		}

		Pt_Collection* pcp = exsiting->rect_query(v1, v2);

		if (pcp->size() >= setting.h) {
			PtsSpace* pt = exsiting->Product(pcp);
			pt->sort(pt->dimNum - 1);
			if (min > pt->v[setting.h - 1][pt->dimNum - 1]) {
				min = pt->v[setting.h - 1][pt->dimNum - 1];
			}
			delete pt;
		} else {
			min = -1;
		}

		delete pcp;
		delete[] v2;

	}

	if (min == -1) {
		delete tpc;
		return -_MAX;
	}

	list_delta_dom2[*tpc_iter] = min;
	delete tpc;

	return min;
}

int price_comp(int q, PtsSpace* local_created) {
	/*
	 * return _MAX if +inf
	 * return min otherwise
	 * */

	counter_comp2++;

	Pt_Collection* tpc = created->rect_query(local_created->v[q],
			local_created->v[q]);
	Pt_Collection::iterator tpc_iter = tpc->begin();

	if (list_delta_comp2[*tpc_iter] != 0) {
		int re = list_delta_comp2[*tpc_iter];
		delete tpc;
		return re;
	}

	int min = _MAX;

	int* v1 = new int[exsiting->dimNum - 1];
	memset(v1, 0, sizeof(int) * (exsiting->dimNum - 1));

	Pt_Collection* pcp = exsiting->rect_query(v1, local_created->v[q]);

	if (pcp->size() == 0) {
		delete pcp;
		delete[] v1;
		delete tpc;
		return _MAX;
	}

	PtsSpace* pt2 = exsiting->Product(pcp);

	pt2->calM();

	if (min > pt2->min[local_created->dimNum - 1]) {
		min = pt2->min[local_created->dimNum - 1];
	}

	delete[] v1;
	delete pt2;
	delete pcp;

	list_delta_comp2[*tpc_iter] = min;

	delete tpc;

	return min;
}

bool test_price_dom() {

	setting.h = 0;

	printf("$$$$$$$$$$$$$$$$$$$$$$$$$$$\n");

	printf("setting.h = %d", setting.h);

	for (int i = 0; i < created->tupleNum; i++) {
		printf("%d\n", price_dom(i));
	}

	setting.h = 1;

	printf("$$$$$$$$$$$$$$$$$$$$$$$$$$$\n");

	printf("setting.h = %d", setting.h);

	for (int i = 0; i < created->tupleNum; i++) {
		printf("%d\n", price_dom(i));
	}

	printf("$$$$$$$$$$$$$$$$$$$$$$$$$$$\n");

	Pt_Collection* pc = new Pt_Collection;

	pc->insert(0);
	pc->insert(1);
	pc->insert(5);

	for (int i = 0; i < 3; i++) {
		printf("%d\n", price_dom(i, created->Product(pc)));
	}

}

bool test_price_comp() {

	printf("$$$$$$$$$$$$$$$$$$$$$$$$$$$\n");

	for (int i = 0; i < created->tupleNum; i++) {
		printf("%d\n", price_comp(i));
	}

	printf("$$$$$$$$$$$$$$$$$$$$$$$$$$$\n");

	for (int i = 0; i < created->tupleNum; i++) {
		printf("%d\n", price_comp(i));
	}

	Pt_Collection* pc = new Pt_Collection;

	printf("$$$$$$$$$$$$$$$$$$$$$$$$$$$\n");

	pc->insert(0);
	pc->insert(1);
	pc->insert(5);

	for (int i = 0; i < 3; i++) {
		printf("%d\n", price_comp(i, created->Product(pc)));
	}

}

int price_con(int q, Pt_Collection* pc) {

	counter_con++;

	if (pc->empty()) {
		printf("error");
	}

	//pc cannot be empty
	PtsSpace* pt = created->Product(pc);
	pt->sort(0);

	for (int m = pt->tupleNum - 1; m >= 0; m--) {

		int min = _MAX;
		int pdom = price_dom(m, pt);
		int pcom = price_comp(m, pt);

		if (pdom > pcom) {
			min = pcom;
		} else {
			min = pdom;
		}

		//pricing(m, pt);
		if (m != pt->tupleNum - 1) {
			for (int n = m + 1; n < pt->tupleNum; n++) {
				int* v1 = pt->v[n];
				int* v2 = pt->v[m];
				if (pt->dominate(v1, v2, pt->dimNum - 1) == 1) {
					if (min > pt->v[n][pt->dimNum - 1]) {
						min = pt->v[n][pt->dimNum - 1];
					}
				}
			}
		}

		pt->v[m][pt->dimNum - 1] = min - setting.sigma;
	}

	int min = _MAX;

	for (int n = 0; n < pt->tupleNum; n++) {
		int* v1 = pt->v[n];
		int* v2 = created->v[q];
		if (pt->dominate(v1, v2, pt->dimNum - 1) == 1) {
			if (min > pt->v[n][pt->dimNum - 1]) {
				min = pt->v[n][pt->dimNum - 1];
			}
		}
	}

	delete pt;

	return min;
}

int delta(int q) {

	counter_del1++;

	int pdom = price_dom(q);
	int pcom = price_comp(q);

	int re = 0;

	if (pdom > pcom) {
		re = pcom;
	} else {
		re = pdom;
	}

	return re - created->v[q][created->dimNum - 1] - setting.sigma; // price-sigma-cost

}

int delta(int q, Pt_Collection* pc) {

	counter_del2++;

	if (pc->empty()) {
		return delta(q);
	}

	int pdom = price_dom(q);
	int pcom = price_comp(q);
	int pconf = price_con(q, pc);

	int re = 0;

	if (pdom < pcom) {
		if (pdom < pconf) {
			re = pdom;
		} else {
			re = pconf;
		}
	} else {
		if (pcom < pconf) {
			re = pcom;
		} else {
			re = pconf;
		}
	}

	if (re == -_MAX) {

	} else if (re == _MAX) {

	}

	return re - created->v[q][created->dimNum - 1] - setting.sigma;

}

bool init(const vector<set<int>::iterator>& s, int t, int* q) {

	int* v = new int[s.size()];
	int* v2 = new int[s.size()];

	for (unsigned int i = 0; i < s.size(); i++) {
		v[i] = *(s[i]);
		v2[i] = 0;
	}

	Pt_Collection* ps = created->rect_query(v2, v);

	delete[] v;
	delete[] v2;

	if (ps->size() > 0) {

		int max = -_MAX, index = 0;

		for (Pt_Collection::iterator i = ps->begin(); i != ps->end(); i++) {
			int del = delta(*i);
			if (del > max) {
				max = del;
				index = *i;
			}
		}

		*q = index;
		delete ps;
		return true;
	}
	delete ps;
	return false;
}

int cal_profit(Pt_Collection* pc) {

	PtsSpace* pt = created->Product(pc);

	//pt->show();

	pt->sort(0);
	int sum = 0;

	for (int m = pt->tupleNum - 1; m >= 0; m--) {

		int min = _MAX;
		int pdom = price_dom(m, pt);
		int pcom = price_comp(m, pt);

		if (pdom > pcom) {
			min = pcom;
		} else {
			min = pdom;
		}

		if (min == -_MAX) {
			delete pt;
			return min;
		}

		//pricing(m, pt);
		if (m != pt->tupleNum - 1) {
			for (int n = m + 1; n < pt->tupleNum; n++) {
				int* v1 = pt->v[n];
				int* v2 = pt->v[m];
				if (pt->dominate(v1, v2, pt->dimNum - 1) == 1) {
					if (min > pt->v[n][pt->dimNum - 1]) {
						min = pt->v[n][pt->dimNum - 1];
					}
				}
			}
		}

		int tp = pt->v[m][pt->dimNum - 1];
		pt->v[m][pt->dimNum - 1] = min - setting.sigma;
		sum += min - setting.sigma - tp;
	}

	delete pt;
	return sum;

}

Pt_Collection* greedy0() {

	int* unsorted = new int[created->tupleNum];
	int* index = new int[created->tupleNum];

	for (int i = 0; i < created->tupleNum; i++) {
		unsorted[i] = delta(i);
		
		index[i] = i;
	}

	quicksort_i(index, unsorted, 0, created->tupleNum - 1);

	int sum = 0;

	for (int i = 0; i < setting.k; i++) {
		sum += unsorted[i];
//		printf("%d,%d\n",i,unsorted[i]);
	}

	big_delta = sum;

	int temp = setting.k * (setting.k - 1);

	//printf("suggested sigma = %f\n", (1.0 * sum) / temp);

	int profit = 0;

	Pt_Collection* s = new Pt_Collection;

	//printf("output 0: ");

	for (int i = 0; i < setting.k; i++) {
//		printf("%d:", index[i]);
		s->insert(index[i]);
	}

	FILE* ptr = (FILE *) fopen("output_greedy0", "w");

	profit = cal_profit(s);
	long mem = created->count();
	mem += exsiting->count();
	mem += sizeof(int) * created->tupleNum * 4;

	fprintf(ptr, "%d,%ld", profit, mem);

	fclose(ptr);

	add_error -= profit;
	profit_greedy0 = profit;

//	delete s;
//	delete[] unsorted;
//	delete[] index;

	return s;
}
;

Pt_Collection * createSi(int q){
	//create intervals with corresponding cps
	// the last attribute is the index of the cp.
	int* v1 = new int[created->dimNum+1];
	int* v2 = new int[created->dimNum+1];
	int* vpmax= new int[created->dimNum+1];

	int size=0;	

	int count=0;
	
	memset(v1, 0, sizeof(int) * (created->dimNum+1));
	memset(v2, 0, sizeof(int) * (created->dimNum+1));
	memset(vpmax, 0, sizeof(int) * (created->dimNum+1));
	Pt_Collection * result = new Pt_Collection;
	
	for (int i = 0; i < created->dimNum+1; i++) {	
			if(i== created->dimNum-1)
			{
				vpmax[i]=delta(q)+created->v[q][created->dimNum - 1] + setting.sigma;
				if (vpmax[i]<0)   
					vpmax[i]=_MAX;  
			}
			else if (i==created->dimNum)
			{
				vpmax[i]=0;
			}
			else
			{
				vpmax[i]=created->v[q][i];			
			}
//		printf("%d:%d ",i,vpmax[i]);
			v2[i]=_MAX;
		}

	
//	Pt_Collection *pccpl=cpl->rect_query(v1, vpmax);
	Pt_Collection *pccpu=cpu->rect_query(vpmax,v2);
	
	if(pccpu->size()==0)
	{
//		printf("test\n");
//		delete pccpl;
		delete pccpu;
		delete[] v1;
		delete[] vpmax;
		delete[] v2;
//		counter_inf_hit++;
//		result->init(0,0,0);
	  
		return result; //return an empty set
	}
/*	
	for (Pt_Collection::iterator i = pccpl->begin(); i != pccpl->end(); i++) {
		int index = *i;
		if (pccpu->find(index)!= pccpu->end())
			{
				pccpl->erase(i);
			}
	}
*/	
/*	
	PtsSpace* ptl = cpu->Product(pccpu);		
	
//	ptl->remove(pccpu);
	
	ptl->sort(ptl->dimNum - 1);	

	
	size = ptl->tupleNum;
	
	result->init(1,size,0);
	
	for(int i=0;i<size;i++)
	{
		memcpy(result->v[count++], &(ptl->v[i][ptl->dimNum-1]), sizeof(int) * result->dimNum);
	}

//	result->sort(0);

	for(int i=0;i<size;i++)
	{
		result->insert(ptl->v[i][ptl->dimNum-1]);
	}
	*/
	return pccpu;	
}

int scgreedy(){
	
	int* unsorted = new int[created->tupleNum];
	int* index = new int[created->tupleNum];

	for (int i = 0; i < created->tupleNum; i++) {
		unsorted[i] = delta(i);
		index[i] = i;
	}

	quicksort_i(index, unsorted, 0, created->tupleNum - 1);

	int sum = 0;

	for (int i = 0; i < setting.k; i++) {
		sum += unsorted[i];
	}

	big_delta = sum;

	int temp = setting.k * (setting.k - 1);

	//printf("suggested sigma = %f\n", (1.0 * sum) / temp);
	
	Pt_Collection **Si=new Pt_Collection*[created->tupleNum];
	//Si=(PtsSpace *)malloc(sizeof(PtsSpace)*created->tupleNum);
	
	Pt_Collection *s = new Pt_Collection;
//	printf("%d\n",cpl->tupleNum);
	
	
	for (int i=0; i<created->tupleNum;i++)
	{	
		Si[i]= new Pt_Collection;		
		Si[i]=createSi(i);
		if(i%100==0)
		printf("Si:%d,%d\n",i,Si[i]->size());
	}
	
	printf("CreateSi done\n");
	int maxtuple=0;
	int maxindex=-1;
	Pt_Collection *max=new Pt_Collection;
	Pt_Collection *p =new Pt_Collection;
	int covered=0;
	int ct;
//	printf("%d,%d,%f\n",covered,cpl->tupleNum,(double)covered/(double)(cpl->tupleNum));
	
	for (int i = 0; i < setting.k; i++) {	
		maxtuple=0;	
		maxindex=-1;
		for (int j=0; j<created->tupleNum;j++)
		{
			p = Si[j];
			if(maxtuple<p->size())
				{
					maxtuple=p->size();
					maxindex=j;
				}			
		}
		if(maxindex!=-1)
		{
			max = Si[maxindex];

			for(Pt_Collection::iterator i = max->begin(); i != max->end(); i++)
			{
				s->insert(*i);
				covered++;
			}
			for(int j=0; j<created->tupleNum;j++)
			{
				p = Si[j];
				
	/*	  	for(Pt_Collection::iterator i = p->begin(); i != p->end(); i++)
		  	{
		  		printf("%d ",*i);
		  	}  							
				printf("\n");
	*/			
				for( Pt_Collection::iterator iter=p->begin(); iter!=p->end();iter++)
				{ 
					if (s->find(*iter)!=s->end())
						{
							p->erase(*iter);
						}
		  	}
	  	
	/*	  
					
				for(Pt_Collection::iterator i = p->begin(); i != p->end(); i++)
		  	{
		  		printf("%d ",*i);
		  	}
		  	printf("\n");
		*/		
	//			getchar();
			
			}
		
		
	  }		

  }
  printf("output sc: ");
  

	  	
  FILE* ptr = (FILE *) fopen("output_scgreedy", "w");
  fprintf(ptr, "%d,%d,%f\n",s->size(),cpu->tupleNum,(double)covered/(double)(cpu->tupleNum));
  printf("%d,%d,%f\n",s->size(),cpu->tupleNum,(double)covered/(double)(cpu->tupleNum));
  fclose(ptr);
  

  
/*
	int profit = 0;

	Pt_Collection* s = new Pt_Collection;

	//printf("output 0: ");

	for (int i = 0; i < setting.k; i++) {
//		printf("%d:", index[i]);
		s->insert(index[i]);
	}

	FILE* ptr = (FILE *) fopen("output_greedy0", "w");

	profit = cal_profit(s);
	long mem = created->count();
	mem += exsiting->count();
	mem += sizeof(int) * created->tupleNum * 4;

	fprintf(ptr, "%d,%ld", profit, mem);

	fclose(ptr);

	add_error -= profit;
	profit_greedy0 = profit;
*/
	delete s;
	delete[] unsorted;
	delete[] index;
	
}


int greedy1() {

	int max = -_MAX, max_index = -1;

	for (int i = 0; i < created->tupleNum; i++) {
		int tp = delta(i);
		if (max < tp) {
			max = tp;
			max_index = i;
		}
	}

	if (max_index == -1) {
		printf("problem unsolvable!!!");
	}

	Pt_Collection* s = new Pt_Collection;

	for (int i = 0; i < setting.k; i++) {

		printf("round %d \n", i);

		max = -_MAX;
		s->insert(max_index);
		for (int j = 0; j < created->tupleNum; j++) {

			if (s->find(j) != s->end())
				continue;

			int tp = delta(j, s);
			if (max < tp) {
				max = tp;
				max_index = j;
			}
		}
	}

	printf("output 1: ");

	for (Pt_Collection::iterator iter = s->begin(); iter != s->end(); iter++) {
		printf("%d:", *iter);
	}

	FILE* ptr = (FILE*) fopen("output_greedy1", "w");

	int profit = cal_profit(s);

	long mem = created->count();
	mem += exsiting->count();

	mem += sizeof(int) * created->tupleNum * 4;

	fprintf(ptr, "%d,%ld", profit, mem);

	fclose(ptr);

	delete s;
}
;

int greedy2() {

	int max = -_MAX, max_index = -1;

	for (int i = 0; i < created->tupleNum; i++) {
		int tp = delta(i);
		if (max < tp) {
			max = tp;
			max_index = i;
		}
	}

	if (max_index == -1) {
		printf("problem unsolvable!!!");
	}

	Pt_Collection* s = new Pt_Collection;

	for (int i = 0; i < setting.k; i++) {

		printf("round %d \n", i);

		max = -_MAX;
		s->insert(max_index);
		for (int j = 0; j < created->tupleNum; j++) {

			if (s->find(j) != s->end())
				continue;

			s->insert(j);
			int tp = cal_profit(s);
			s->erase(j);

			if (max < tp) {
				max = tp;
				max_index = j;
			}
		}
	}

	printf("output 2: ");

	for (Pt_Collection::iterator iter = s->begin(); iter != s->end(); iter++) {
		printf("%d:", *iter);
	}

	FILE* ptr = (FILE*) fopen("output_greedy2", "w");

	int profit = cal_profit(s);
	long mem = created->count();
	mem += exsiting->count();
	mem += sizeof(int) * created->tupleNum * 4;

	fprintf(ptr, "%d,%ld", profit, mem);

	fclose(ptr);

	delete s;
}
/*
 int estimation(){

 int* unsorted = new int[created->tupleNum];
 int* index = new int[created->tupleNum];

 for (int i=0;i < created->tupleNum; i++){
 unsorted[i] = delta(i);
 index[i] = i;
 }

 quicksort_i(index, unsorted, 0, created->tupleNum-1);

 int sum = 0;

 for(int i=0;i<setting.k;i++){
 sum += unsorted[i];
 }

 FILE* ptr = (FILE *)fopen("output4", "w");

 long mem = created->count();
 mem += exsiting->count();
 mem += sizeof(int) * created->tupleNum * 4;

 fprintf(ptr,"%d",sum);

 fclose(ptr);

 delete[] unsorted;
 delete[] index;
 };*/

void randomized() {

	srand(time(0));

	int* unsorted = new int[created->tupleNum];
	int* index = new int[created->tupleNum];

	for (int i = 0; i < created->tupleNum; i++) {
		unsorted[i] = delta(i);
		index[i] = i;
	}

	int base = (setting.k * 10) % created->tupleNum;
	int max_profit = 0;

	int numOfround = 100000;

	if (created->tupleNum > 50000) {
		numOfround = 10000;
	}

	quicksort_i(index, unsorted, 0, created->tupleNum - 1);

	Pt_Collection* s = new Pt_Collection;

	for (int run = 0; run < numOfround; run++) {
		if (run % 1000 == 0) {
			printf("%f \% \n", run * 100.0 / numOfround);
		}

		for (int i = 0; i < setting.k; i++) {
			int seed = rand() % base;
			while (s->find(index[seed]) != s->end()) {
				seed++;
			}
			s->insert(index[seed]);
		}

		int temp_profit = cal_profit(s);

		if (temp_profit > max_profit)
			max_profit = temp_profit;

		s->clear();
	}

	FILE* ptr = (FILE*) fopen("output_randomized", "w");

	fprintf(ptr, "%d", max_profit);

	fclose(ptr);

}

int round() {

	int max = 0;
	Pt_Collection s;

	do {

		s.clear();

		for (int i = 0; i < created->tupleNum; i++) {
			int d = delta(i, &s);
			if (d > max) {
				if (rand() % 2) {
					max = d;
					s.insert(i);
				}
			}

			if (s.size() == setting.k) {
				break;
			}
		}

	} while (s.size() < setting.k);

	return cal_profit(&s);

}

void randomized2() {

	for (int i = 0; i < 1000; i++) {
		printf("round %d: %d \n", i, round());
	}

}

void burtoforce(Pt_Collection & s, int index, int& max_profit) {

	if (s.size() == setting.k) {

		//quick check
		int temp_profit = 0;

		for (Pt_Collection::iterator iter = s.begin(); iter != s.end(); iter++) {
			temp_profit += delta(*iter);
		}

		if (temp_profit < max_profit) {
			return;
		}

		//common check
		temp_profit = cal_profit(&s);

		if (max_profit < temp_profit) {
			//printf("\n=================\n");


			//			for(Pt_Collection::iterator iter = s.begin();iter != s.end();iter++){
			//				printf("%d ",*iter);
			//			}

			//printf("\n=================\n");
			max_profit = temp_profit;
		}

	} else {
		for (int i = index; i < created->tupleNum; i++) {
			s.insert(i);
			burtoforce(s, i + 1, max_profit);
			s.erase(i);
		}
	}

	return;
}

void run_burteforce() {

	int max = 0, index = 0;
	Pt_Collection s;

	burtoforce(s, index, max);

	FILE* ptr = (FILE*) fopen("output_burteforce", "w");

	long mem = created->count(); //table created
	mem += exsiting->count(); //table exsiting
	mem += sizeof(int) * created->tupleNum * 4; //cache
	fprintf(ptr, "%d,%ld", max, mem);

	add_error = max;
	profit_optimal = max;

	fclose(ptr);
}

void dp2d() {

	//created->show();

	Pt_Collection** SS = new Pt_Collection*[created->tupleNum];
	int** TT = new int*[created->tupleNum];

	for (int i = 0; i < created->tupleNum; i++) {
		SS[i] = new set<int> [setting.k + 1];
		TT[i] = new int[setting.k + 1];
		memset(TT[i], 0, (setting.k + 1) * sizeof(int));
	}

	for (int i = 1; i < created->tupleNum; i++) {
		for (int t = 1; t < setting.k + 1; t++) {

			if (t > i)
				continue;

			int d = delta(i, &SS[i - 1][t - 1]);

			if (t > i - 1) {
				SS[i][t].insert(SS[i - 1][t - 1].begin(),
						SS[i - 1][t - 1].end());
				SS[i][t].insert(i);
				TT[i][t] = TT[i - 1][t - 1] + d;

				continue;

			}

			if (TT[i - 1][t - 1] + d > TT[i - 1][t]) {
				SS[i][t].insert(SS[i - 1][t - 1].begin(),
						SS[i - 1][t - 1].end());
				SS[i][t].insert(i);

				TT[i][t] = TT[i - 1][t - 1] + d;

				//				printf("%d \n",TT[i][t]);

			} else {
				SS[i][t].insert(SS[i - 1][t].begin(), SS[i - 1][t].end());
				TT[i][t] = TT[i - 1][t];

			}

		}
	}

	for (Pt_Collection::iterator i =
			SS[created->tupleNum - 1][setting.k].begin(); i
			!= SS[created->tupleNum - 1][setting.k].end(); i++) {
		printf("%d:", *i);
	}

	printf("\n");

	for (int i = 1; i < created->tupleNum; i++) {
		for (int t = 1; t < setting.k + 1; t++) {
			printf("%d ", TT[i][t]);
		}
		printf("\n");
	}

	FILE* ptr = (FILE*) fopen("output_dp", "w");

	long mem = created->count(); //table created
	mem += exsiting->count(); //table exsiting
	mem += sizeof(int) * created->tupleNum * 4; //cache

	mem += created->tupleNum * setting.k * sizeof(int); //TT
	mem += created->tupleNum * setting.k * sizeof(int) * (setting.k / 2) * 3; //SS

	int max_profit = cal_profit(&SS[created->tupleNum - 1][setting.k]);

	fprintf(ptr, "%d,%ld", max_profit, mem);

	fclose(ptr);

}

void test() {

	test_price_dom();
	test_price_comp();

}

void reInitCounter() {
	counter_dom1 = 0;
	counter_dom2 = 0;
	counter_comp1 = 0;
	counter_comp2 = 0;
	counter_con = 0;
	counter_del1 = 0;
	counter_del2 = 0;
	counter_inf_hit = 0;
	counter_ninf_hit = 0;
	counter_total = 0;
}

void OutputCounter(char* name) {

	FILE *filePtr;

	filePtr = (FILE *) fopen(name, "w");

	fprintf(filePtr, "%d %d %d %f %f", counter_total, counter_inf_hit,
			counter_ninf_hit, (1.0) * counter_inf_hit / counter_total, (1.0)
					* counter_ninf_hit / counter_total);

	fclose(filePtr);

}

void Merge(PtsSpace *s, PtsSpace *t, PtsSpace *fin)
{
	//PtsSpace *fina=new PtsSpace;
	
	fin->init(s->dimNum,s->tupleNum+t->tupleNum,s->dimNum-1);
	
	for (int i = 0; i < fin->tupleNum; i++) {
		if(i<s->tupleNum)
		{
			for (int j = 0; j < s->dimNum; j++) {
				fin->v[i][j]=s->v[i][j];
			}
		}
		else
		{
			for (int j = 0; j < t->dimNum; j++) {
				fin->v[i][j]=t->v[i-s->tupleNum][j];
			}
		}
	}
	
}

Pt_Collection * update0(PtsSpace *s)
{
	Pt_Collection *ns= new Pt_Collection;
	PtsSpace *tmp=new PtsSpace;
	printf("begin Merge\n");
	inserttuple->bnl();
	Merge(exsiting,inserttuple,s);
	                                       
	tmp=exsiting;
	exsiting=s;
	s=tmp;    
	exsiting->indexed_flag=false;
	exsiting->bnl();        
	exsiting->build_index();
	printf("begin recompute\n");
	ns=greedy0();	
	return ns;

}

Pt_Collection *update1(int *unsorted, int *index, Pt_Collection *olds)
{
	
	PtsSpace *stp=new PtsSpace;	
	Pt_Collection *rt= new Pt_Collection;
/*	int *mk=new int[created->tupleNum];
	
	for(int i=0;i<created->tupleNum;i++)
		mk[i]=0;*/
	
	printf("begin recompute:\n ");
//	inserttuple->bnl();
	Pt_Collection* s = new Pt_Collection;
	int* v2 = new int[created->dimNum];
	int* v1 = new int[created->dimNum];

		for (int i = 0; i < created->dimNum; i++) {
			v2[i] = _MAX;
		}

//	inserttuple->build_index();	

//check p_new based- property 
	int ct=0;
	for(int i=0;i<inserttuple->tupleNum;i++)
	{
		s->clear();
		s=exsiting->rect_query(inserttuple->v[i],v2);
		if(s->size()==0)
			{
				ct++;
			}
			else
				break;
	}
	
	if(ct==inserttuple->tupleNum)
	{
		printf("No change1!\n");
	
		return olds;
	}
	else
	{	
		//check Q'-Based Property		
		
		int count=0;		
		
		for(Pt_Collection::iterator j = olds->begin(); j != olds->end(); j++)
		{
			for (int i = 0; i < created->dimNum-1; i++) {
				v1[i]=created->v[*j][i];
				v2[i]=-_MAX;
			}
			v1[created->dimNum-1]=unsorted[*j]+created->v[*j][created->dimNum-1];
			v2[created->dimNum-1]=-_MAX;
			s->clear();
			s=inserttuple->rect_query(v2,v1);
			if(s->size()>0)
			{
				int mini=_MAX;
				for(Pt_Collection::iterator l = s->begin(); l != s->end(); l++)
				{ 
					if(mini>inserttuple->v[*l][inserttuple->dimNum-1])
						mini=inserttuple->v[*l][inserttuple->dimNum-1];
				}
				unsorted[*j]=mini-setting.sigma-created->v[*j][created->dimNum-1];
			}
			else 
			{
				count++;
			}
		}
		
		if(count==setting.k)
		{
			printf("No change2!\n");
			return olds;
		}
		else
		{		
			quicksort_i(index, unsorted, 0, created->tupleNum - 1);
			s->clear();
			for (int i = 0; i < setting.k; i++) {
				s->insert(index[i]);
			}
			return s;	
		}
	}	

}

int delete0()
{
	long i;
	int count=0;

//deletetuple->bnl();	
	printf("%d\n",deletetuple->tupleNum);
	Pt_Collection *s= new Pt_Collection;
	for(i=0;i<deletetuple->tupleNum;i++)
	{
//		printf("%d\n",i);
		s=exsiting->rect_query(deletetuple->v[i],deletetuple->v[i]);
		if(s->size()>0)
		{
//			printf("%d\n",i);
//			count++;
			exsiting->remove(exsiting->rect_query(deletetuple->v[i],deletetuple->v[i]));
//			break;
		}
	}
/*	if(count==0)
	{
		printf("No change0!\n");
	}
	else*/
//	printf("remove done\n");
		exsiting->bnl();
		exsiting->indexed_flag=false;
		exsiting->build_index();
		greedy0();
	
}

Pt_Collection *delete1(int *unsorted, int *index, Pt_Collection *s)
{
  
	int count=0;
	Pt_Collection *tp = new Pt_Collection;
	Pt_Collection *tot = new Pt_Collection;
	//PtsSpace *old= new PtsSpace;
	//old->Product(s);
//	deletetuple->bnl();	
	
	for(long i=0;i<deletetuple->tupleNum;i++)
	{
		
		if(exsiting->rect_checking(deletetuple->v[i])==true)
		{
			count++;
			break;
//			tp=exsiting->rect_query(deletetuple->v[i],deletetuple->v[i]);
//			tot->insert(*(tp->begin()));			
		}
	}
	if(count==0)
	{
		printf("No change1!\n");
		return s;
	}
	else
	{
//			tp->clear();
//			tot->clear();
			int* v2 = new int[created->dimNum];

			for (int i = 0; i < created->dimNum; i++) {
				v2[i] = _MAX;
			}
	
			for(long i=0;i<deletetuple->tupleNum;i++) {
				tp=created->rect_query(deletetuple->v[i],v2);
				for(Pt_Collection::iterator j = tp->begin(); j != tp->end(); j++)
				{
					tot->insert(*j);
				}				
			}		
			
			for(Pt_Collection::iterator j = tot->begin(); j != tot->end(); j++)
			{
				unsorted[*j]=delta(*j);
			}
			
			quicksort_i(index, unsorted, 0, created->tupleNum - 1);
		
			s->clear();
			for (int i = 0; i < setting.k; i++) {
		//		printf("%d:", index[i]);
				s->insert(index[i]);
			}
			
			return s;
				
	}
}

int main(int argc, char** argv) {

	FILE* pFile;
	char temp[1024];
	
	getrusage(RUSAGE_SELF, &myTime_program_start);
	
	if (argc != 2) {
		printf("algorithm requires 6 parameters, k, h, d, sigma, t");
	}
	
	

	sprintf(temp,"./%s/config",argv[1]); 
	if ((pFile = fopen(temp, "r")) == NULL) {
		printf("reading error!!!");
		return 0;
	}
	
	fscanf(pFile,"%s",temp);
	setting.k = atoi(temp);
	fscanf(pFile,"%s",temp);
	setting.h = atoi(temp);
	fscanf(pFile,"%s",temp);
	setting.d = atof(temp);
	fscanf(pFile,"%s",temp);
	setting.sigma = atoi(temp);
	fscanf(pFile,"%s",temp);
	setting.t=atoi(temp);
	fscanf(pFile,"%s",temp);
	setting.r1=atoi(temp);
	fscanf(pFile,"%s",temp);
	setting.r2=atoi(temp);
	

	fclose(pFile);

	Pt_Collection* s = new Pt_Collection;
	Pt_Collection* ns = new Pt_Collection;
	PtsSpace *tp=new PtsSpace;
	
	PtsSpace *olde=new PtsSpace;
	PtsSpace *oldc=new PtsSpace;
	PtsSpace *oldi=new PtsSpace;
	PtsSpace *oldd=new PtsSpace;

	
	load_file(argv[1]);
	printf("begin\n");
	//getrusage(RUSAGE_SELF, &myTime_prep_end);
	//run_burteforce();
	//getrusage(RUSAGE_SELF, &myTime_algo1_end);
	
	if(setting.t==0)
	{
		getrusage(RUSAGE_SELF, &myTime_prep_end);		 
		s=greedy0();
		getrusage(RUSAGE_SELF, &myTime_algo1_end);	
		getrusage(RUSAGE_SELF, &myTime_algo2_end);	
	}
	else if (setting.t==1)
	{
		s=greedy0();
		load_update(argv[1]);
		getrusage(RUSAGE_SELF, &myTime_prep_end);						
		update0(tp);
		getrusage(RUSAGE_SELF, &myTime_algo1_end);	  
		load_file(argv[1]);
		s=greedy0();
		int* unsorted = new int[created->tupleNum];
		int* index = new int[created->tupleNum];
	
		for (int i = 0; i < created->tupleNum; i++) {
			unsorted[i] = delta(i);
			
			index[i] = i;
		}
		
		getrusage(RUSAGE_SELF, &myTime_algo2_end);	
		
	  update1(unsorted, index, s);	
	  
	  getrusage(RUSAGE_SELF, &myTime_algo3_end);
  	Merge(exsiting,inserttuple,tp);
		exsiting=tp;
//		exsiting->bnl();
		exsiting->build_index();	
	}
	else if (setting.t==2)
	{
		
	}
	else if (setting.t==3)
	{	
		getrusage(RUSAGE_SELF, &myTime_prep_end);
		scgreedy();		
		getrusage(RUSAGE_SELF, &myTime_algo1_end);
		getrusage(RUSAGE_SELF, &myTime_algo2_end);
	}
	else if (setting.t==4)
	{
		s=greedy0();
		load_update(argv[1]);
		getrusage(RUSAGE_SELF, &myTime_prep_end);
		//greedy0();
		delete0();
		getrusage(RUSAGE_SELF, &myTime_algo1_end);
		load_file(argv[1]);
		int* unsorted = new int[created->tupleNum];
		int* index = new int[created->tupleNum];
	
		for (int i = 0; i < created->tupleNum; i++) {
			unsorted[i] = delta(i);
			
			index[i] = i;
		}
		getrusage(RUSAGE_SELF, &myTime_algo2_end);
		delete1(unsorted,index,s);
	}
	else if (setting.t==5)
	{
		s=greedy0();
		int* unsorted = new int[created->tupleNum];
		int* index = new int[created->tupleNum];
	
		for (int i = 0; i < created->tupleNum; i++) {
			unsorted[i] = delta(i);
			
			index[i] = i;
		}
		load_update(argv[1]); 

		printf("load update done\n"); 
		getrusage(RUSAGE_SELF, &myTime_prep_end);						
		update0(tp);
//	printf("update0 done\n");
//		greedy0();    
		delete0();
//		exsiting->bnl();          
//		exsiting->build_index();	            
//		printf("greedy0 done\n");  
		getrusage(RUSAGE_SELF, &myTime_algo1_end);	  
		load_file(argv[1]);
		load_update(argv[1]);	
	  
		getrusage(RUSAGE_SELF, &myTime_algo2_end);			
	  ns=update1(unsorted, index, s);	  
    Merge(exsiting,inserttuple,tp);      
//   exsiting=tp;
 		exsiting->bnl(); 
 		exsiting->indexed_flag=false;         
	  exsiting->build_index();			
	  delete1(unsorted,index,s);
//  exsiting->bnl();   
//		exsiting->build_index();	 
//	  printf("delete0 done\n");  
	}
	getrusage(RUSAGE_SELF, &myTime_algo3_end);

	double add_bound = setting.k * (setting.k -1) /2 * setting.sigma;
	double mult_bound = add_bound / big_delta;
	double mult_error = 1-profit_greedy0 / profit_optimal;

	//printf("\nAdditive error %lf : Additive bound %lf", add_error, add_bound);
	//printf("\nMulti error %lf : Multi bound %lf", mult_error, mult_bound);

//	printf("%lf,%lf,%lf,%lf \n",add_error,add_bound,mult_error,mult_bound );

	::printTimeFile(argv[1]);

	delete created;
	delete exsiting;
	delete[] list_delta_comp;
	delete[] list_delta_comp2;
	delete[] list_delta_dom;
	delete[] list_delta_dom2;

	return 0;
}
